<?php
/**
 * $Horde: trean/edit.php,v 1.34 2005/08/24 05:30:24 selsky Exp $
 *
 * Copyright 2002-2005 Mike Cochrane <mike@graftonhall.co.nz>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */

@define('TREAN_BASE', dirname(__FILE__));
require_once TREAN_BASE . '/lib/base.php';

$actionID = Util::getFormData('actionID');
$category_id = Util::getFormData('category_id', $trean_shares->getId(Auth::getAuth()));
$bookmark_id = Util::getFormData('bookmark_id');

if (!is_array($bookmark_id)) {
    $bookmark_id = array($bookmark_id => true);
}

switch ($actionID) {
case 'save_bookmark':
    $url = Util::getFormData('url');
    $title = Util::getFormData('title');
    $description = Util::getFormData('description');
    $rating = Util::getFormData('rating');
    $new_category = Util::getFormData('new_category');
    $delete = Util::getFormData('delete');
    $redirect = Util::getFormData('redirect');
    if (count($bookmark_id)) {
        foreach ($bookmark_id as $id => $stuff) {
            $bookmark = &$trean_shares->getBookmark($id);
            if (isset($delete[$id])) {
                $result = $trean_shares->removeBookmark($bookmark);
                if (!is_a($result, 'PEAR_Error')) {
                    $notification->push(_("Deleted bookmark: ") . $bookmark->get('title'), 'horde.success');
                } else {
                    $notification->push(sprintf(_("There was a problem deleting the bookmark: %s"), $result->getMessage()), 'horde.error');
                }
            } else {
                $bookmark->set('url', $url[$id]);
                $bookmark->set('title', $title[$id]);
                $bookmark->set('description', $description[$id]);
                $bookmark->set('rating', $rating[$id]);

                if (isset($redirect[$id])) {
                    $bookmark->set('url', $bookmark->get('http-Location'));
                    $bookmark->set('http-status', '');
                    $bookmark->set('http-status-count', 0);
                    $bookmark->set('http-Location', '');
                }

                $result = $bookmark->update();

                if ($new_category[$id] != $bookmark->getParent()) {
                    $category = &$trean_shares->getCategory($new_category[$id]);
                    $result = $bookmark->move($category);
                }

                if (is_a($result, 'PEAR_Error')) {
                    $notification->push(sprintf(_("There was an error saving the bookmark: %s"), $result->getMessage()), 'horde.error');
                } 
            }
        }
    }

    $url = Util::addParameter('browse.php', 'category_id', $category_id);
    header('Location: ' . Horde::applicationUrl($url, true));
    exit;

case 'delete_bookmark':
    if (count($bookmark_id)) {
        foreach ($bookmark_id as $id => $delete) {
            if ($delete) {
                $bookmark = &$trean_shares->getBookmark($id);
                $result = $trean_shares->removeBookmark($bookmark);
                if (!is_a($result, 'PEAR_Error')) {
                    $notification->push(_("Deleted bookmark: ") . $bookmark->get('title'), 'horde.success');
                } else {
                    $notification->push(sprintf(_("There was a problem deleting the bookmark: %s"), $result->getMessage()), 'horde.error');
                }
            }
        }
    }

    // Return to the category listing
    $url = Util::addParameter('browse.php', 'category_id', $category_id);
    header('Location: ' . Horde::applicationUrl($url, true));
    exit;
    break;
    

case 'move_bookmark':
    $create_category = Util::getFormData('create_category');
    $new_category = Util::getFormData('new_category', DATATREE_ROOT);
    
    /* Create a new category if requested */
    if ($create_category) {
        $properties = array();
        $properties['name'] = $new_category;

        $parent_id = $trean_shares->getId(Auth::getAuth());
        $parent = &$trean_shares->getCategory($parent_id);
        $result = $parent->addCategory($properties);
        
        if (is_a($result, 'PEAR_Error')) {
            $notification->push(sprintf(_("There was an error adding the category: %s"), $result->getMessage()), 'horde.error');
        } else {
            $new_category = $result;
        }
    }

    $new_category = &$trean_shares->getCategory($new_category);

    if (count($bookmark_id)) {
        foreach ($bookmark_id as $id => $move) {
            if ($move) {
                $bookmark = &$trean_shares->getbookmark($id);
                $result = $bookmark->move($new_category);
                if (!is_a($result, 'PEAR_Error')) {
                    $notification->push(_("Moved bookmark: ") . $bookmark->get('title'), 'horde.success');
                } else {
                    $notification->push(sprintf(_("There was a problem moving the bookmark: %s"), $result->getMessage()), 'horde.error');
                }
            }
        }
    }

    // Return to the category listing
    $url = Util::addParameter('browse.php', 'category_id', $category_id);
    header('Location: ' . Horde::applicationUrl($url, true));
    exit;
    break;

case 'copy_bookmark':
    $create_category = Util::getFormData('create_category');
    $new_category = Util::getFormData('new_category', DATATREE_ROOT);
    
    /* Create a new category if requested */
    if ($create_category) {
        $properties = array();
        $properties['name'] = $new_category;

        $parent_id = $trean_shares->getId(Auth::getAuth());
        $parent = &$trean_shares->getCategory($parent_id);
        $result = $parent->addCategory($properties);
        
        if (is_a($result, 'PEAR_Error')) {
            $notification->push(sprintf(_("There was an error adding the category: %s"), $result->getMessage()), 'horde.error');
        } else {
            $new_category = $result;
        }
    }

    $new_category = &$trean_shares->getCategory($new_category);

    if (count($bookmark_id)) {
        foreach ($bookmark_id as $id => $copy) {
            if ($copy) {
                $bookmark = &$trean_shares->getbookmark($id);
                $result = $trean_shares->copy($bookmark, $new_category);
                if (!is_a($result, 'PEAR_Error')) {
                    $notification->push(_("Copied bookmark: ") . $bookmark->get('title'), 'horde.success');
                } else {
                    $notification->push(sprintf(_("There was a problem copying the bookmark: %s"), $result->getMessage()), 'horde.error');
                }
            }
        }
    }

    // Return to the category listing
    $url = Util::addParameter('browse.php', 'category_id', $category_id);
    header('Location: ' . Horde::applicationUrl($url, true));
    exit;
    break;

case 'rename':
    /* Rename a Bookmark Category. */
    $name = Util::getFormData('name');

    $category = &$trean_shares->getCategory($category_id);
    $result = $category->set('name', $name, true);

    if (is_a($result, 'PEAR_Error')) {
        $notification->push(sprintf(_("\"%s\" was not renamed: %s."), $name, $result->getMessage()), 'horde.error');
    } else {
        $url = Util::addParameter('browse.php', 'category_id', $category_id);
        header('Location: ' . Horde::applicationUrl($url, true));
        exit;
    }
    break;

case 'del_category':
    $category = &$trean_shares->getCategory($category_id);
    $parent = $category->getParent();

    $category->delete();

    header('Location: ' . Horde::applicationUrl(Util::addParameter('browse.php', 'category_id', $parent), true));
    exit;
    break;

case 'delete_categories':
    $category = Util::getFormData('category');
    if (count($category)) {
        foreach ($category as $id => $delete) {
            if ($delete) {
                $cat = &$trean_shares->getCategory($id);
                $result = $cat->delete();
                if (!is_a($result, 'PEAR_Error')) {
                    $notification->push(_("Deleted category: ") . $cat->get('name'), 'horde.success');
                } else {
                    $notification->push(sprintf(_("There was a problem deleting the category: %s"), $result->getMessage()), 'horde.error');
                }
            }
        }
    }

    $url = Util::addParameter('browse.php', 'category_id', $category_id);
    header('Location: ' . Horde::applicationUrl($url, true));
    exit;

case 'move_categories':
    $category = Util::getFormData('category');

    $create_category = Util::getFormData('create_category');
    $new_category = Util::getFormData('new_category', DATATREE_ROOT);
    
    /* Create a new category if requested */
    if ($create_category) {
        $properties = array();
        $properties['name'] = $new_category;

        $parent_id = $trean_shares->getId(Auth::getAuth());
        $parent = &$trean_shares->getCategory($parent_id);
        $result = $parent->addCategory($properties);
        
        if (is_a($result, 'PEAR_Error')) {
            $notification->push(sprintf(_("There was an error adding the category: %s"), $result->getMessage()), 'horde.error');
        } else {
            $new_category = $result;
        }
    }

    $new_category = &$trean_shares->getCategory($new_category);

    if (count($category)) {
        foreach ($category as $id => $delete) {
            if ($delete) {
                $cat = &$trean_shares->getCategory($id);
                $result = $trean_shares->move($cat, $new_category);
                if (!is_a($result, 'PEAR_Error')) {
                    $notification->push(_("Moved category: ") . $cat->get('name'), 'horde.success');
                } else {
                    $notification->push(sprintf(_("There was a problem moving the category: %s"), $result->getMessage()), 'horde.error');
                }
            }
        }
    }

    $url = Util::addParameter('browse.php', 'category_id', $category_id);
    header('Location: ' . Horde::applicationUrl($url, true));
    exit;

}

//$category = &$trean_shares->getCategory($category_id);
//$bookmark = &$trean_shares->getBookmark($bookmark_id);

$title = _("Edit Bookmark");
require TREAN_TEMPLATES . '/common-header.inc';
require TREAN_TEMPLATES . '/menu.inc';
require TREAN_TEMPLATES . '/edit/header.inc';
if (count($bookmark_id)) {
    foreach ($bookmark_id as $id => $edit) {
        if ($edit) {
            $bookmark = &$trean_shares->getBookmark($id);
            $category_id = &$bookmark->getParent();
            require TREAN_TEMPLATES . '/edit/edit.inc';
        }
    }
}
require TREAN_TEMPLATES . '/edit/footer.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
