<?php
/**
 * Trean external API interface.
 *
 * This file defines Trean's external API interface. Other
 * applications can interact with Trean through this API.
 *
 * $Horde: trean/lib/api.php,v 1.13 2005/06/01 15:26:08 jan Exp $
 *
 * Copyright 2002-2005 Mike Cochrane <mike@graftonhall.co.nz>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */

$_services['perms'] = array(
    'args' => array(),
    'type' => '{urn:horde}stringArray');

$_services['list'] = array(
    'args' => array('parent' => 'int'),
    'type' => '{urn:horde}stringArray'
);


function _trean_perms()
{
    $perms = array();

    $perms['tree']['trean']['max_categories'] = false;
    $perms['title']['trean:max_categories'] = _("Maximum Number of Categories");
    $perms['type']['trean:max_categories'] = 'int';
    $perms['tree']['trean']['max_bookmarks'] = false;
    $perms['title']['trean:max_bookmarks'] = _("Maximum Number of Bookmarks");
    $perms['type']['trean:max_bookmarks'] = 'int';

    return $perms;
}

function _trean_list($parent = DATATREE_ROOT)
{
    require_once dirname(__FILE__) . '/base.php';

    $ids = Trean::listAllBookmarks($parent);
    if (is_a($ids, 'PEAR_Error')) {
        return $ids;
    }

    $bookmarks = array();
    foreach ($ids as $id => $name) {
        $bookmark = &$GLOBALS['trean_shares']->getBookmark($id);
        $bookmarks[] = array('title' => $bookmark->get('title'),
                             'description' => $bookmark->get('description'),
                             'url' => $bookmark->get('url'));
    }

    return $bookmarks;
}
