<?php
$option_move = Trean::countCategories(PERMS_EDIT);
$option_copy = $option_move &&
    (!empty($conf['hooks']['permsdenied']) ||
     Trean::hasPermission('max_bookmarks') === true ||
     Trean::hasPermission('max_bookmarks') > $GLOBALS['trean_shares']->countBookmarks());
$option_edit = $GLOBALS['category']->hasPermission(Auth::getAuth(), PERMS_EDIT);
$option_delete = $GLOBALS['category']->hasPermission(Auth::getAuth(), PERMS_DELETE);
$option_select = $option_move || $option_delete;
?>

<?php if ($GLOBALS['prefs']->getValue('display_edit') && count($GLOBALS['bookmarks'])) : ?>
<form name="bookmarks" action="<?php echo Horde::applicationURL('edit.php') ?>" method="post">
<input type="hidden" name="actionID" value="" />
<input type="hidden" name="category_id" value="<?php echo $GLOBALS['category_id'] ?>" />
<input type="hidden" name="create_category" value="0" />
<input type="hidden" name="new_category" value="" />
<?php endif; ?>

<div class="header">
 <?php echo $GLOBALS['category']->get('name') ?>
</div>

<?php if ($GLOBALS['prefs']->getValue('display_edit') && count($GLOBALS['bookmarks']) && $option_select) : ?>
<table class="control" style="width:100%" cellspacing="0"><tr>
<td>
<?php printf(_("Select: %s, %s"),
             Horde::link('#', _("Select All"), 'widget', '', 'selectAllBookmarks(); return false;') . _("All") . '</a>',
             Horde::link('#', _("Select None"), 'widget', '', 'selectNoBookmarks(); return false;') . _("None") . '</a>') ?>
</td><td style="text-align:right">
<?php
if ($option_edit) {
    echo Horde::link('#', '', 'widget', '', 'editSelectedBookmarks(); return false;') . _("Edit") . '</a>';
}
if ($option_delete) {
    if ($option_edit) {
        echo ' | ';
    }
    echo Horde::link('#', '', 'widget', '', 'deleteSelectedBookmarks(); return false;') . _("Delete") . '</a>';
    if ($option_move) {
        echo ' | ' . Horde::link('#', '', 'widget', '', 'moveSelectedBookmarks(); return false;') . _("Move") . '</a>';
    }
}
if ($option_copy) {
    if ($option_delete || $option_edit) {
        echo ' | ';
    }
    echo Horde::link('#', '', 'widget', '', 'copySelectedBookmarks(); return false;') . _("Copy") . '</a>';
}
?>
&nbsp;<select name="selected_category"><?php echo Trean::categorySelect($GLOBALS['category_id'], PERMS_EDIT, null, DATATREE_ROOT, true, 0, 0, true) ?></select>
 <?php if ($option_edit): ?>
 <select name="other_actions" onchange="otherActions()">
  <option><?php echo _("More Actions") ?> ...</option>
<?php if ($option_copy): ?>
  <option value="new_bookmark"><?php echo _("New Bookmark"); ?></option>
<?php
endif;
if (!empty($conf['hooks']['permsdenied']) ||
    Trean::hasPermission('max_categories') === true ||
    Trean::hasPermission('max_categories') > Trean::countCategories()):
?>
  <option value="new_subcategory"><?php echo _("New Subcategory"); ?></option>
<?php endif; ?>
  <?php if ($GLOBALS['category']->getParent() != DATATREE_ROOT): ?>
    <option value="delete_category"><?php echo _("Delete this Category"); ?></option>
    <option value="rename_category"><?php echo _("Rename this Category"); ?></option>
  <?php endif; ?>
  <?php if ($GLOBALS['category']->get('owner') == Auth::getAuth()): ?>
    <option value="set_permissions"><?php echo _("Set Permissions"); ?></option>
  <?php endif; ?>
 </select>
 <?php endif; ?>
</td></tr></table>
<?php endif; ?>

<div>
<?php
if (count($GLOBALS['bookmarks'])) {
    // Number of columns to display.
    $cols = $GLOBALS['prefs']->getValue('browse_columns');

    echo '<table style="width:100%" cellspacing="8"><tr>';
    $count = 0;
    foreach ($GLOBALS['bookmarks'] as $bookmark) {
        echo '<td class="box" style="width:' . floor(100 / $cols) . '%" valign="top">';
        require TREAN_TEMPLATES . '/bookmark/' . $GLOBALS['prefs']->getValue('bookmark_template') . '.inc';
        echo '</td>';
        if (!(++$count % $cols)) {
            echo '</tr><tr>';
        }
    }

    // If the last row is incomplete, fill it in.
    while ($count++ % $cols) {
        echo '<td>&nbsp;</td>';
    }

    echo '</tr></table>';
} else {
    if ($option_edit) {
        echo '<div class="control">';
        $div = false;
        if ($option_copy) {
            echo '<a href="javascript:otherActions(\'new_bookmark\')" class="widget">' . _("New Bookmark") . '</a>';
            $div = true;
        }
        if (!empty($conf['hooks']['permsdenied']) ||
            Trean::hasPermission('max_categories') === true ||
            Trean::hasPermission('max_categories') > Trean::countCategories()) {
            if ($div) {
                echo ' | ';
            }
            echo '<a href="javascript:otherActions(\'new_subcategory\')" class="widget">' . _("New Subcategory") . '</a>';
            $div = true;
        }
        if ($GLOBALS['category']->getParent() != DATATREE_ROOT) {
            if ($div) {
                echo ' | ';
            }
            echo '<a href="javascript:otherActions(\'delete_category\')" class="widget">' . _("Delete this Category") . '</a>';
            echo ' | <a href="javascript:otherActions(\'rename_category\')" class="widget">' . _("Rename this Category") . '</a>';
            $div = true;
        }
        if ($GLOBALS['category']->get('owner') == Auth::getAuth()) {
            if ($div) {
                echo ' | ';
            }
            echo '<a href="javascript:otherActions(\'set_permissions\')" class="widget">' . _("Set Permissions") . '</a>';
        }
        echo '</div>';
    }
    echo '<span style="font-style:italic">' . _("There are no bookmarks in this category") . '</span>';
}
?>
</div>

<?php if ($GLOBALS['prefs']->getValue('display_edit') && count($GLOBALS['bookmarks'])) echo '</form>' ?>
